---
title: Immutable Linux CoreOS как среда для бегущего в Gitlab тест контейнера
date: 2025-01-20
authors:
  - gardener
slug: container-driven-development
description: >
   Взгляд на преимущество неизменяемых компонент через призму Immutable Linux и Immutable Kotlin Class (Value Object)  
categories:
  - linux
  - coreos
  - gitlab
  - gitlab runner
  - devops
  - container driven approach
draft: true
---

# Container Driven Development 
Привет, netrunner.



<!-- more -->
---
## Container Driven Development а.k.а Container-First Approach


Разработка на основе контейнеров — это процесс разработки в котором мы пишем код, а запускаем и тестируем код внутри контейнера.
Контейнер — это переносимый упакованный файл, который содержит приложение (часто структурированное как микросервис) вместе с его исходным кодом или бинарным исполняемым файлом,
библиотеками, прочими зависимостями, необходимыми для корректного исполнения.

Идея упрощения сложного приложения до контейнера дает ряд преимуществ:

- консистентное развертывание и выполнение
- переносимость приложения.  
  один и тот же артефакт может использоваться в средах dev, stage, production.

Контейнеры позволяют запускать приложения вне зависимости от ОС хоста или конфигурации ОС,
так как содержат все необходимые зависимости внутри контейнера.
Для исполнения "большинства" приложений в контейнерах требуется поддержка хостом контейнеров.

>Бывают исключения, которые требуют меньшей изоляции от ресурсов хоста. Например: для исполнения testContainer-ов нам нужно прокинуть docker.sock.
Такую задачу я и решаю в рамках развертывания gitlab runner-а на изолированной машине.  
Мне нужна ровно одна вещь (функция) - производительный раннер для запуска тест-контейнеров.

Контейнеры решают ряд проблем в разработке программного обеспечения и дают нам возможность вести кросс-платформенную разработку,
тем самым упрощают разработку, сборку, тестирование, доставку приложения на среды исполнения.

Из простых примеров использования на рабочей станции:

## Я хочу запустить и протестировать СУБД.

Я могу запустить контейнер с СУБД, провести необходимые эксперименты и удалить контейнер.
Моя операционная система при этом не тронута. Могу я это сделать как на винде, так и на Linux.
А ты макалюб, страдай, я не напишу тебе ни строчки 3:)

## Я хочу написать Dart код, скомпилировать, запустить не изменяя настройки хоста
| Я могу запустить контейнер сконфигурированный для работы с этим языкром программирования,  
| передать контейнеру в качестве параметров на вход папку с исходниками  
| Скомпилить приложение в контейнере
| Запустить, собранное приложение, в контейнере

