---
title: Immutable Linux CoreOS как среда для бегущего в Gitlab тест контейнера
date: 2025-01-17
authors:
  - gardener
slug: Immutable-linux-coreos
description: >
   Взгляд на преимущество неизменяемых компонент через призму Immutable Linux и Immutable Kotlin Class (Value Object)  
categories:
  - linux
  - coreos
  - gitlab
  - gitlab runner
  - devops
  - container driven approach
draft: true
---

# Immitable Linux CoreOS как среда для бегущего в Gitlab тест контейнера 
Привет, netrunner.
Мегасити никогда не спит. Мегасити майнит все, что способна переварить машина.
Последний звонок по работе пыльным облаком упал тебе на плечо и отразилось болью в мышце.

Ты думаешь, что можешь справиться с этим? Ну-ну. 
Посмотрим, как ты справишься с миром, где неизменность — это не просто концепция, а жестокая реальность.

Когда наступает ночь, ты обнаруживаешь, что пишешь веб-бук про эффективное программирование. 
Ты собираешь свое домашнее облако, как будто это твой личный ад, и экспериментируешь с железяками, linux дистрибутивами и devOps инструментами. 
Надежный удобочитаемый код — это твоя мания, твоя одержимость.

Ты готовишь Gitlab Runner для запуска тест контейнеров на отдельной машине и 
решаешь взглянуть на неизменность (Immutable) в срезе программирования и администрирования. 
Immutable Linux и immutable классы в объектно-ориентированном программировании — это твои новые игрушки, 
твои инструменты для пыток.

Тебе не хочется писать ansible скрипты, нет. 
Ты хочешь посмотреть на неизменяемые дистро от Fedora CoreOs и openSUSE MicroOS. 
Один файл на вход, который описывает работоспособную конфигурацию, и флэшка для прожига драйва машины на выход.
Это все что тебе нужно.
Простая документация? Да. Файл будет тебе этой документацией. 
Ты хочешь понять, как долго ты будешь разбираться с примером. Уже полночь. Кофе остыл.

Все получается быстро, слишком быстро. 
Ты тратишь всего 5 часов, и все работает. 
Ты смотришь на тему неизменности объектов с точек зрения Immutable Linux, как объекта инфраструктуры, и Immutable Object, как объекта кода.

Ты пишешь эссенцию, чтобы не забыть и не свихнуться:    

- про практичность Container Driven Development  
- про Immutable linux и в частности про Fedora CoreOS  
про неизменяемы классы и преимущества жизни в immutable null safety universe  
пример файла конфигурации CoreOS для работоспособной машины типа Gitlab Runner  
Ты думаешь, что получилось интересно? Надеюсь, ты прав.  

Можно накатывать дистро с флэшки или из сети, 
а потом ансиблом катить конфигурацию по-старому. Пахнет машинным маслом. Процессор передает привет.   
Ты наслаждаешься экспериментом с Immutable Linux, гарантируешь автономную накатку инструментом самого дистрибутива и изготавливаешь gitlab runner для test containers. 
Этим ты занимаешься, а по пути пишешь о важных темах.

Запуск гитлаб раннеров на отдельной ВМ или Хосте — это лучшая практика. Ты знаешь это, и ты готов к этому вызову.



---
Когда наступает ночь - я пишу веб-бук про эффективное программирование, собираю домашнее облако разработчика, экспериментирую с железяками, linux дистрибутивами, devOps инструментами, надежным удобочитаемым кодом и всякими релевантными моим интересам темами.  

Пока я готовил Gitlab Runner для запуска тест контейнеров на отдельной машине решил посмотреть на неизменность (Immutable) в срезе программирования и администрирования.  
Immutable Linux и immutable классы в объектно-ориентированном программировании — это интересные и важные темы.

Мне не хотелось писать ansible скрипты, хотелось посмотреть на неизменяемые дистро от **Fedora CoreOs**, **openSUSE MicroOS**.
Я хотел чтобы на вход был один файл, который описывает работоспособную конфигурацию, а на выходе флэшка для прожига машины.
Параллельно я исследую насколько простая документация в мире открытого исходного кода и как долго я буду разбираться с примером.
Все получилось быстро и все работает. На эксперименты я потратил в общей сложности часов 5.
В тексте я посмотрю на тему неизменности объектов с точек зрения Immutable Linux, как объекта инфраструктуры, и Immutable Object, как объекта кода.  

Я коротко напишу:    
- про практичность Container Driven Development  
- про Immutable linux и в частности про Fedora CoreOS  
- про неизменяемы классы и преимущества жизни в immutable null safety universe
- в конце будет пример файла конфигурации CoreOS для работоспособной машины типа Gitlab Runner 

Мне кажется получилось интересно, надеюсь тебе зайдет.

Можно накатывать дистро с флэшки или из сети, а потом ансиблом катить конфигурацию по-старому.
Можно насладиться экспериментом с Immutable Linux, гарантировать автономную накатку инструментом самого дистрибутива и изготовить gitlab runner для test containers.
Этим я и займусь, а по пути напишу о важных темах.   


Запуск гитлаб раннеров на отдельной ВМ или Хосте считается [лучшей практикой](https://docs.gitlab.com/runner/fleet_scaling/).

<!-- more -->
---

# Immutable null safety universe

Прекрасная статья на [сайте о Flutter](https://dart.dev/null-safety/understanding-null-safety) тебе поможет понять важную тему.

> Неизменяемая установка - это простота, воспроизводимость.

## Основным преимуществам неизменяемой инфраструктуры:

Инфраструктура описана файлами конфигурации и, как правило, хранится в гите. 
Это значит можно восстановить инфру из кода в соответствии с версией.

1. Постоянство и надежность: поскольку серверы заменяются, а не изменяются, 
   инфраструктура остается в известном, стабильном состоянии. 
   Это исключает риск возникновения непредвиденных проблем, возникающих из-за изменений или несоответствий в среде.
   Поверь, нет ничего страшнее, чем обновлять сервак, на котором может отвалиться критически важный софт для бизнеса.
   Это кошмар для админа. Обновить ХОСТ в свое время было чертовски страшным дерьмом.  
   Вот почему ты все еще работаешь на кластере монго 5-ти летней давности. Обновить кластер это пипец страшно.

2. Повышенная безопасность: поскольку серверы не изменяются после развертывания, 
   Поверхность атаки остается постоянной и предсказуемой. С одной стороны ты ничего не меняешь в настройках безопасности хоста и
   постоянно работаешь с консистентным объектом под атакой. 
   Это упрощает защиту инфраструктуры и обнаружение любых аномалий или нарушений. 
   В случае инцидента безопасности новый, чистый экземпляр может быть быстро и легко развернут, 
   что минимизирует последствия.

3. Упрощенная отладка и менеджмент: поскольку инфраструктура остается в известном состоянии, устранение неполадок становится проще и понятнее. Ошибки можно изолировать и устранять более эффективно, сокращая время простоя и повышая доступность услуг.  
   Систему легко восстановить до исходного состояния в случае проблем.

4. Масштабируемость и производительность: поскольку новые экземпляры можно быстро и легко развернуть, 
   можно масштабировать систему в соответствии с требованиями. 
   Кроме того, устраняя непредсказуемость, связанную с изменениями и обновлениями, 
   можно оптимизировать производительность и поддерживать ее на постоянном уровне.

## Преимущества неизменяемых объектов в программировании
В программировании Консистентный неизменяемый объект - это простота и стабильность.
Неизменяемый или иммутабельный объект (в работе мы говорим иммутабельный объект) - это объект состояние которого не может быть изменено после создания.
С таким объектом просто и надежно работать, он не выстрелит тебе в ногу в полете до приземления со второго этажа.



Изменяемое Состояние - это сложное поведение объекта, которое нужно контролировать дополнительно.
У админов тоже стресс от изменения состояния конфигурации хоста. Вспоминай.

Итак я выписываю приемущества иммутабельности:

1. Безопасная многопоточная разработка (thread safety)

   Учитывая, что по определению неизменяемый объект не может быть изменен, при его использовании у вас не возникнет никаких проблем с синхронизацией.
   Независимо от того, какой поток обращается к версии объекта, объект гарантированно будет иметь то же состояние, что и изначально. 
   Если одному потоку нужна новая версия или измененная версия этого объекта, он должен создать новую, все другие потоки по-прежнему будут безопасно работать со своим объект.

2. Всегда валидное ясное состояние    
   **Это и есть суть инкапсуляции.**  
   Марк Симан:   
   
   > «Инкапсуляция - одна из наиболее неправильно понимаемых концепций ООП. Многие программисты считают, что это запрет на прямое раскрытие полей классов поля классов должны быть «инкапсулированы» за геттерами и сеттерами. Наиболее важно то, что объект должен гарантировать, что никогда не окажется в невалидном состоянии.»  

   Состояние объекта всегда известно и не может быть изменено, что упрощает понимание кода.
   
3. Простота тестирования  

   Вместе с правильной инкапсуляцией за руку идет код, который проще тестировать, так как поведение immutable объекта предсказуемо. 
   Преимущества тестируемого кода очевидны и ведут к более надежной и безошибочной кодовой базе. 
   Когда ваш код разработан с неизменяемыми объектами вы строите свой софт из стабильных кирпичиков, который покрыты тестами из коробки.   

4. Такой код легко читать и поддерживать  

   Любой фрагмент кода, который описан с неизменяемым объектом, не влияет на другие области вашего кода,   
   использующие этот объект в негативном ключе. 
   Это означает, что в вашем коде меньше нестабильных частей. 
   Поэтому ваш код скорее будет чище и понятнее при таком подходе. Ведь вы начинаете смекать.
 

Состояние само по себе - это сложно, вы как разработчики знаете это.  
Админы это знают.  

Новички разработчики, знайте: **состояние = сложно**.  

Тут сразу рождается много дополнительных паттернов о которых в моменте я ничего не хочу знать. 
Это и защита при многопоточности для сохранения консистентного состояния объекта во времени, 
дополнительные методы проверки состояния у самого объекта 
и далее можно выступать с докладами про всю эту сложность и как мы ее создаем, а потом боремся с ней. 

Изменяемое состояние - это сложная сложность.  
Сложная сложность = зло.  
Другого нет.  

Смекаешь?  
**Savvy?**  
![img.png](savvy.png)  


Когнитивная нагрузка возрастает. 

**Какая главная задача инженера?**    

- Не заболеть головой и заработать денег
- Главная задача инженера - **УПРОЩАТЬ**  

Развивать свой СложноДар (радар на сложность), когнетивная нагрузка возрастает - СложноДар начинает истерично верещать.

Зачем нам лишние действия, если можно работать в иммутабельном безопасной null safety вселенной?
Эта вселенная ближе к комиксовой вселенной DC, тут нет марвеловского тепла и позитива. 
Тут свихнувшиеся на эффективности инженеры и нет примитивной полярности про белое и черное. 
Или есть?
![img.png](witches.png)
![img.png](witche.png)

Прагматичный минимализм, где нет места лишним шагам - достаточно полярен сам по себе. 

## Пример неизменяемого объекта

Иммутабельность можно гарантировать в момент создания объекта.
Это и есть инкапсуляция, как я написал выше.

Тут я провожу аналогию с объектом Неизменяемая конфигурация ОС и Неизменяемым Объектом значением (Value Object), 
который "гарантирует свою консистентность" средствами фабричного метода или умного конструктора.

Посмотрите как можно описать неизменяемый класс на kotlin.
Обеспечить невозможность невалидного состояния мы можем за счет того,
что объявляем приватным конструктор и создаем сам класс благодаря фабричному методу.


Пример на kotlin:
````kotlin

        data class Email private constructor(
            val email: String
        ) {
            companion object {
                fun emerge(email: String): Result<Email> =
                    if (EMAIL_ADDRESS
                            .matches(email)
                    )
                        Result.success(Email(email))
                    else
                        Result.failure(IllegalArgumentException("Invalid email: $email"))
        
            }
        }


````

Если интересен сам паттерн:
````kotlin
        val EMAIL_ADDRESS = Regex(
           "[a-zA-Z0-9\\+\\.\\_\\%\\-\\+]{1,256}" +
                   "\\@" +
                   "[a-zA-Z0-9][a-zA-Z0-9\\-]{0,64}" +
                   "(" +
                   "\\." +
                   "[a-zA-Z0-9][a-zA-Z0-9\\-]{0,25}" +
                   ")+"
        )
````

Тест такого класса продемонстрирует работу с таким классом и простоту тестирования.

Test:
````kotlin
package team.codemonsters.refactoringexample.valueObject

import org.assertj.core.api.Assertions.assertThat
import org.junit.jupiter.api.Test

internal class EmailTest {

    @Test
    fun `should not create email with invalid email`() {
        // arrange
        val invalidEmail = "invalidEmail"
        // act
        val result = Email.emerge(invalidEmail)
        // assert
        assertThat(result.isFailure).isTrue
    }

    @Test
    fun `should create email with valid email`() {
        // arrange
        val validEmail = "hPbqJ@example.com"
        // act
        val result = Email.emerge(validEmail)
        // assert
        assertThat(result.isSuccess).isTrue
    }
}
````


## Вывод номер 1:
Используйте неизменяемые объекты инфраструктуры, неизменяемы классы в при программировании.


## Что такое неизменяемый дистро Linux?

**Immutable Linux** — это операционная система, в которой основные компоненты, включая корневую файловую систему, предназначены только для чтения и не могут быть изменены после развёртывания системы.


Любые изменения в системе временные и теряются при её перезагрузке. Любые обновления или изменения вносятся путём создания нового экземпляра ОС, его развёртывания и переключения на новый экземпляр.

Некоторые преимущества immutable Linux:

- **Повышенная безопасность.** Предотвращение прямых модификаций критических системных файлов значительно снижает риск уязвимостей и брешей безопасности. 
- **Улучшенная стабильность системы.** Корневая файловая система только для чтения гарантирует, что основная система остаётся в известном хорошем состоянии, исключая возможность случайных модификаций или дрейфа конфигурации, которые могут дестабилизировать систему.  


Immutable Linux подходит для критических систем, таких как облачные контейнерные платформы, встроенные системы или устройства IoT, где важны стабильность, безопасность и масштабируемость.


Вы можете добавлять/удалять файлы для хранения, запускать сервисы. 
Данные будут храниться, как обычно, в указанных вами разделах. 
Однако любые изменения, требующие доступа уровня администратора, просто не будут применяться. 
Любое изменение на уровне системы будет временным (если это произойдет), 
и изменение будет потеряно после перезагрузки.

Неизменяемые дистрибутивы также обрабатывают обновления особым образом, 
который подразумевает замену всей операционной системы новыми компонентами, 
например, новую установку, а не просто обновление пакетов с гарантией, 
например, что докер окружение будет работать стабильно. 

# Неизменяемая (immutable) минималистичная CoreOS linux от Fedora
> Получилась отличная шляпа.   

[Fedora COREOS](https://docs.fedoraproject.org/en-US/fedora-coreos/) оптимизированная для работы с контейнерами OS.
Минималистичная ОС с автоматическими обновлениями.
Масштабируемая и безопасная.
Поддерживает преимущества Container Driven Development.

> Fedora CoreOS — это автоматически обновляемая, минимальная, монолитная,
ориентированная на контейнеры операционная система,
разработанная для кластеров, но также прекрасно работает автономно,
оптимальна для Kubernetes, но также отличная подходит для других задач с контейнерами.

Задачу, которую решает — предоставляет лучший контейнерный хост для безопасного и масштабируемого запуска контейнерных рабочих нагрузок.

## Суть неизменяемости в Fedora CoreOS
Одним из основных принципов Fedora CoreOS является неизменяемость.
В традиционных операционных системах обновляются отдельные пакеты.
В Fedora CoreOS обновления применяются атомарно как полная замена всей ОС.
Такой подход обеспечивает согласованность и надежность во всех развертываниях.
Он также устраняет потенциальные проблемы с дрифтом (Configuration drift) или потенциальных проблем, вызванных инкрементальными обновлениями.

Конфигурационный дрифт — это когда рабочие среды отклоняются от базовой или стандартной конфигурации с течением времени. Это отклонение может возникать по разным причинам, включая ручное вмешательство, обновления программного обеспечения и факторы окружающей среды.

Накину тебе интересный список неизменяемых дистрибутивов:

- NixOS,  
- openSUSE MicroOS,    
- fedora CoreOs,    
- Talos Linux  
 

# Зажигаем сердце машины средствами CoreOS
В этом разделе я пишу про накатку настроенного и готового к работе Linux на железяку (Bare Metal)](https://docs.fedoraproject.org/en-US/fedora-coreos/bare-metal/)  


Итак, мне на вход в функцию механикуса для оживления машины типа Gitlab Runner понадобятся следующие входные данные:  

Входные данные:    
- docker  
- разобраться с человеко-читаемым конфигом заливки во вселенной Fedora CoreOS в формате yaml это [бутан](https://docs.fedoraproject.org/en-US/fedora-coreos/producing-ign/)    
- эксперимент с конфигурацией gitlab runner для запуска тестов с тест контейнерами [(testContainer)](https://java.testcontainers.org/supported_docker_environment/continuous_integration/gitlab_ci/)   
- эксперимент конфигурации заливки дистрибутива  

Что мне нужно сделать, чтобы иметь под рукой простой повторяемый опыт:  

Docker, usb drive, комп или виртуалку.  
Выбирай сам из [списка на сайте coreos](https://docs.fedoraproject.org/en-US/fedora-coreos/bare-metal/)  

| человеко-читаемый файл конфигурации бутан  
| скачиваю актуальную версию ISO дистро  
| Прожигаю флешку дистрибутивом  
| тулзой от CoreOS я генерю Файл Зажигания компа  
| Загружаю комп с флешки  
| Прошиваю диск с файлом зажигания и раннер готов  


## пишу человеко-читаемый файл конфигурации бутан 
Файл описывает одну функцию - gitlab runner для Fedora Core OS для Bare Metal  

Fedora Core OS Gitlab runner butane example:  
```yaml 
variant: fcos
version: 1.6.0
passwd:
  users:
    - name: core
      ssh_authorized_keys:
        - ssh-ed25519 AAAA.... gardener@gitlab-micro-runner
storage:
  # Setting the time zone via Ignition https://docs.fedoraproject.org/en-US/fedora-coreos/time-zone/
  links:
    - path: /etc/localtime
      target: ../usr/share/zoneinfo/Europe/Moscow
  files:
    # Setting a Hostname 
    - path: /etc/hostname
      mode: 0644
      contents:
        inline: micro-runner-0
    
    # https://java.testcontainers.org/supported_docker_environment/continuous_integration/gitlab_ci/
    - path: /opt/config.toml
      overwrite: true
      contents:
        inline: |
          [[runners]]
            name = "micro-runner-0"
            url = "{url-gitlab}"
            token = "{token-gitlab}"
            limit = 4
            executor = "docker"
            [runners.docker]
              tls_verify = false
              image = "docker:latest"
              privileged = false
              disable_entrypoint_overwrite = false
              oom_kill_disable = false
              disable_cache = false
              volumes = ["/var/run/docker.sock:/var/run/docker.sock", "/cache"]
              shm_size = 0
    
    # https://docs.fedoraproject.org/en-US/quick-docs/selinux-changing-states-and-modes/          
    - path: /etc/selinux/config
      overwrite: true
      contents: 
        inline: |
          SELINUX=*permissive*
          SELINUXTYPE=targeted

# https://docs.fedoraproject.org/en-US/fedora-coreos/running-containers/
systemd:
  units:
    - name: docker.service
      enabled: true
    - name: gitlab-runner.service
      enabled: true
      contents: |
        [Unit]
        Description=Gitlab Runner in container
        After=network-online.target
        Wants=network-online.target

        [Service]
        ExecStart=/usr/bin/docker run --name gitlab-runner --rm -v /opt/config.toml:/etc/gitlab-runner/config.toml:Z -v /var/run/docker.sock:/var/run/docker.sock:Z docker.io/gitlab/gitlab-runner
        
        ExecStop=/usr/bin/docker stop gitlab-runner

        [Install]
        WantedBy=multi-user.target
```

**Обрати внимание**:  
Далее шаги в идеально демонстрируют Container Driven Approach.

## Загружаю актуальную версию ISO образа дистро из сети
````
docker run --security-opt label=disable --pull=always --rm -v .:/data -w /data \
    quay.io/coreos/coreos-installer:release download -s stable -p metal -f iso
````
## Прожигаю usb drive ISO образом
````zsh
sudo dd if=fedora-coreos-41.20241215.3.0-live.x86_64.iso of=/dev/sdc bs=1024 status=progress && sync

````

## тулзой от CoreOS я генерю машино-читаемый (json) файл зажигания компа из понятного человеку бутана (ямл)
````zsh
docker run --interactive --rm quay.io/coreos/butane:release \
       --pretty --strict < runner-core.bu.yaml > runner-core.ign

````
## Загружаю комп с флешки
![img_1.png](lector.png)

## Прошиваю диск компа linux в соответствии с конфигом, зажигаем машину
[Подробная инфа про разновидности снабжения машин](https://docs.fedoraproject.org/en-US/fedora-coreos/bare-metal/)

Две строчки. Заливка на диск nvme заняла чуть больше минуты и машина ожила.  
````zsh
sudo coreos-installer install /dev/nvme0n1 \
    --i runner-core.ign
    
sudo reboot    
````
Нехватает механического треска старых компов.  
И сообщения на экране зеленым цветом.  
Machine Gitlab Runner up and running.    

# Тестирование
TBD  
есть идеи как автоматом убедиться, что прошивка корректна. На практике, я раза три-четыре дорабатывал конфиг и ходил к машине с флешкой.  

## Заключиние

Дистрибутив выполняет свою функцию. Автономно прожигает диск компа стабильным ядром и сервисом, который исполняет свое предназначение в контейнере и все это описано в одном файле.  
На мой взгляд хороший подход к автономности дистрибутива.  

Функция проста:  

> f(файл_с_конфигом)=сервис_на_хосте_работает

Надеюсь, мне удалось провести аналогии о пользе и простоте неизменяемых объектов конфигурации и объектов в кодовой базе. 
Неизменяемость - это просто, простота всегда напрямую влияет на надежность.  
Надежность мы получаем, в том числе, благодаря простоте тестирования.  

Я хожу на конференции по мобильной разработке, по тестированию, по бэкенду и девопсу.
Мы как инженеры часто не обращаем внимание на сложность, потому что мы к ней привыкаем.  
Когда я стал работать менеджером ИТ и вечерами исследовать вопросы инженерного дела, я свежим взглядом тупого менеджера посмотрел на свои "простые решения".  

И осознал еще сильнее: Нам стоит чаще рассказывать про упрощение, а не про сложные решения.  
Мы инженеры с упоением рассказывают про сложные Пепяки. Я сам такой. Часто мы сложность решаем еще большей сложностью.  
Просто потому что, когда мы в потоке, мы не обращаем внимания на сложность нашего решения.  

Мобильщики не обращают внимание, что есть Сomposable Code и изи тестбл код и придумывают решения как тестировать сложный интерфейс.
Например: Flutter и Dart описывают UI классами, Android jetpack compose - интерфейс = класс.  
Что это значит? Я могу его тестировать юнит-тестом.   
Мне не нужно для этого поднимать мобильное приложение и кликать кликером по кнопкам, проверять результат.    
Я могу это протестировать компонентным тестом.    

Инженеры, компонентные тесты - это просто. Нужно проектировать код так, чтобы было просто тестировать.  
Делай себе жизнь проще.    

Я ничего не хочу знать про ваши сложные пепяки тестирования интерфейсов и интеграционные тесты на пре-прод средах.  
Сделайте рефакторинг, покажите как вы тестируете все юнит-тестами и немного простыми компонентными тестами.  
Инвестируй в перспективу правильных и простых решений.  
Упрощение - это достойная задача, а достижение простоты - достойная тема доклада.    

Админы могут [тестировать](https://docs.fedoraproject.org/en-US/fedora-coreos/tutorial-services/#_testing) конфигурацию иммутабельной ОС.  

Сначала был код.  

Затем я услышал шум вентиляторов сердца машины.  

Благодарю, что прочитал до конца.
Пиши мне в моем телеграм канале https://t.me/codemonsterslogs 

# Полезные ссылки
- [Immutable Linux](https://dev.to/khozaei/immutable-linux-4a4a)
- [Understanding Immutable Linux OS](https://kairos.io/blog/2023/03/22/understanding-immutable-linux-os-benefits-architecture-and-challenges/)
- [Unlocking the power of Fedora CoreOS - Fedora Magazine](https://fedoramagazine.org/unlocking-the-power-of-fedora-coreos/)
- [5 Benefits of a Container-First Approach to Software Development](https://www.docker.com/blog/5-benefits-of-a-container-first-approach-to-software-development/)
## Пс
Обрати внимание, что документация, примеры - [все хранится в гите](https://coreos.github.io/coreos-installer/cmd/install/)

Лаконичной документацией с рабочими примерами мне нравится вселенная Fedora.
Также хочу отметить прекрасную документацию Gentoo и посоветовать тем, кто хочет понять как работает linux установить и разобраться с этим милым пингвином  

- https://fedoraproject.org/  
- https://www.gentoo.org/  
